<template>
  <section>
    <h4>Create function that generate possible strings of size N in set of N
characters.</h4>
    <div id="searchBox">
      <label id="inputGenerate">
        Enter generate strings:
        <input v-model="lettleString" @keyup.enter="gnerate"></input>
      </label>
      <button @click="gnerate">Generate</button>
    </div>
    <p v-if="result !== ''">
      {{`Generated result: ${sumText} ${result}`}}
    </p>
  </section>
</template>

<script>
  export default {
    data() {
      return {
        lettleString: '',
        result: '',
        sumText: ''
      }
    },
    watch: {
      lettleString() {
        const vm = this
        vm.result = ''
      }
    },
    methods: {
      gnerate() {
        const vm = this
        //logic
        const arrangementData = (lettle) => {
          let results = []
          if (lettle.length === 1) {
            results.push(lettle)
          }
          for (let i = 0; i < lettle.length; i++) {
            let firstChar = lettle[i];
            let charsLeft = lettle.substring(0, i) + lettle.substring(i + 1);
            let innerPermutations = arrangementData(charsLeft);
            for (let j = 0; j < innerPermutations.length; j++) {
              results.push(firstChar + innerPermutations[j]);
            }
          }
          return results;
        }
        const data = arrangementData(vm.lettleString)
        // Check duplicate data
        let findDuplicateData = data.filter(function(item, index) {
          if (data.findIndex(e => e === item) == index)
            return item;
        })
        vm.result = findDuplicateData.join(", ").toUpperCase()
      }
    }
  }
</script>

<style scoped>
  input {
    outline: none;
    border-radius: 4px !important;
    border: solid 1px #c4c4c4 !important;
    background-color: #ffffff;
    padding: 5px 10px 5px 10px;
  }
  input:focus {
    border: 1px solid #36a3f7 !important;
    border-radius: 4px;
  }
  button {
    cursor: pointer;
    outline: none;
    border: none !important;
    padding: 5px;
    border-radius: 5px;
    background: #3b8aff;
    color: white;
    box-shadow: 0px 3px 1px -2px rgba(0, 0, 0, 0.2),
    0px 2px 2px 0px rgba(0, 0, 0, 0.14),
    0px 1px 5px 0px rgba(0, 0, 0, 0.1)
  }
  p {
    word-break: break-word;
  }
</style>